; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)			
;																				
TIMER_AKTIVIEREN:
	ldi temp,(0<<OCIE2)|(1<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(0<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER2 (8Bit) Vorteiler														
;																				
; TCCR2 ==> FOC2 WGM20 COM21 COM20 WGM21 CS22 CS21 CS20 						
; CS22 CS21 CS20 Description													
;	0	0 	0 	No clock source (Timer/Counter stopped).						
;	0 	0 	1 	clkT2S/		(No prescaling)										
; 	0 	1 	0 	clkT2S/8 	(From prescaler)									
;	0 	1 	1 	clkT2S/32 	(From prescaler)									
; *	1 	0 	0 	clkT2S/64 	(From prescaler)									
;	1 	0 	1 	clkT2S/128 	(From prescaler)									
;	1 	1 	0 	clkT2S/256 	(From prescaler)									
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
TIMER2_1ms_INITIALISIERUNG:
.equ TIMERWERT2=(256-125)		;(2 hoch 8  minus...) 8MHz VT:64--->125
	ldi temp,(1<<CS22)|(0<<CS21) |(0<<CS20)  
	out TCCR2,temp  
	ldi temp,(TIMERWERT2)		; Startwert
	out TCNT2,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1ms																			
TIM2_OVF:
	push TEMP		    	; Sichern von "TEMP" im Stack			
	in	 TEMP,SREG			; Einlesen des SREG 					
	push TEMP	    		; Schreiben von  SREG  im Stack (KOPIE)	
	push TEMP1
;-------------------------------------------------------------------------------
	ldi temp,(TIMERWERT2)	; Startwert
	out TCNT2,temp
;-------------------------------------------------------------------------------
; UHR-ms (Millisekunden)														
	LDS temp ,(adr_ms_L)
	LDS temp1,(adr_ms_H)
	add temp ,EINS
	adc temp1,NULL
	STS(adr_ms_L),temp
	STS(adr_ms_H),temp1
	cpi temp ,low (1000)
	brne TIM2_OVF_FERTIG
	cpi temp1,high(1000)
	brne TIM2_OVF_FERTIG
	STS(adr_ms_L),NULL
	STS(adr_ms_H),NULL
;-------------------------------------------------------------------------------
TIM2_1s:
	rcall UHR				; UHR
;-------------------------------------------------------------------------------
TIM2_OVF_FERTIG:
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 		
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
UHR:
	LDS temp,(adr_ss)
	inc temp
	cpi temp,60
	brsh UHR_mm
	STS (adr_ss),temp
	ret
;-------------------------------------------------------------------------------
UHR_mm:
	STS (adr_ss),NULL
	LDS temp,(adr_mm)
	inc temp
	cpi temp,60
	brsh UHR_hh
	STS (adr_mm),temp
	ret
;-------------------------------------------------------------------------------
UHR_hh:
	STS (adr_mm),NULL	; in SRAM speichern	
	LDS temp,(adr_hh)	; aus SRAM laden	
	inc temp
	cpi temp,24
	brsh UHR_hh_NULL
	STS (adr_hh),temp	; in SRAM speichern	
	ret
;-------------------------------------------------------------------------------
; TAG																			
UHR_hh_NULL:
	STS (adr_hh),NULL
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
