; Bernhard.Erfurt@gmx.de						
; 01/2021										
;												
;												
; 128 x 64 Pixel=8.192 Pixel :8=1024			
; ATmega8 										
; 8MHz											
.include "m8def.inc"
.include "MACROS.asm"
.equ TAKT							= 8000000	; 8 MHz
; ERROR CODES									
.equ ERROR_TWI_MT_START			=0x20
.equ ERROR_TWI_MT_DATA			=0x22
.equ ERROR_TWI_MR_START			=0x23
.equ ERROR_TWI_MR_DATA			=0x25
.equ ERROR_TWI_MR_DATAEND		=0x26

.equ ERROR_BME680_NOT_FOUND		=0x6E
.equ ERROR_BME680_ID			=0x68
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR			= 5
.equ LED_GRUEN_DDR				= DDRD
.equ LED_GRUEN_PORT				= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR			= 6
.equ LED_GELB_DDR				= DDRD
.equ LED_GELB_PORT				= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR				= 7
.equ LED_ROT_DDR				= DDRD
.equ LED_ROT_PORT				= PORTD
; REGISTER										

.def UHR_COUNTER_L	= R6
.def UHR_COUNTER_H	= R7
.def OLED_X 		= R10
.def OLED_Y 		= R11
.def ERROR	= R12
.def NULL 	= R13
.def EINS 	= R14
.def VOLL 	= R15
.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

; SRAM-BELEGUNG										
.equ adr_DATEN						= SRAM_START		; 0x0060 START Adresse 						



.equ adr_ms_L						=SRAM_START+21
.equ adr_ms_H						=SRAM_START+22
.equ adr_ss							=SRAM_START+23	; Sekunden					
.equ adr_mm							=SRAM_START+24	; Minuten					
.equ adr_hh							=SRAM_START+25	; Stunden

.equ adr_ADC_BETRIEBSSPANNUNG		=SRAM_START+40

.equ adr_ASCII_FONT					=SRAM_START+50
.equ adr_ASCII_BEREICH_OZ			=SRAM_START+51	; obere  Zeile				
.equ adr_ASCII_BEREICH_UZ			=SRAM_START+70 	; untere Zeile				

.equ adr_BME680_STATUS 				=SRAM_START+100 ; Reset(01h)
.equ adr_BME680_RESET 				=SRAM_START+101 ; Reset(00h)
.equ adr_BME680_ID 					=SRAM_START+102 ; Reset(61h)
.equ adr_BME680_CONFIG 				=SRAM_START+103 ; Reset(00h)
.equ adr_BME680_Ctrl_MEAS 			=SRAM_START+104 ; Reset(00h)
.equ adr_BME680_Ctrl_HUM 			=SRAM_START+105 ; Reset(00h)
.equ adr_BME680_Ctrl_GAS_1 			=SRAM_START+106 ; Reset(00h)
.equ adr_BME680_Ctrl_GAS_0 			=SRAM_START+107 ; Reset(00h)
.equ adr_BME680_Gas_WAIT_x			=SRAM_START+108	; Reset(00h) 6Dh64h
.equ adr_BME680_Res_HEAT_x 			=SRAM_START+109	; Reset(00h) 63h5Ah
.equ adr_BME680_Idac_HEAT_x 		=SRAM_START+110	; Reset(00h) 59h50h
.equ adr_BME680_gas_R_lsb 			=SRAM_START+111	; Reset(00h)
.equ adr_BME680_gas_R_msb 			=SRAM_START+112	; Reset(00h)
.equ adr_BME680_HUM_lsb 			=SRAM_START+113	; Reset(00h)
.equ adr_BME680_HUM_msb 			=SRAM_START+114	; Reset(80h)
.equ adr_BME680_TEMP_xlsb 			=SRAM_START+115	; Reset(00h)
.equ adr_BME680_TEMP_lsb 			=SRAM_START+116	; Reset(00h)
.equ adr_BME680_TEMP_msb 			=SRAM_START+117	; Reset(80h)
.equ adr_BME680_PRESS_xlsb 			=SRAM_START+118	; Reset(00h)
.equ adr_BME680_PRESS_lsb 			=SRAM_START+119	; Reset(00h)
.equ adr_BME680_PRESS_msb 			=SRAM_START+120	; Reset(80h)
.equ adr_BME680_EAS_status			=SRAM_START+121	; Reset(00h)


.equ adr_SRAM_CHECK					=SRAM_START+900	; Programm-Check	
.equ adr_SRAM_ENDE					=SRAM_START+1023


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0
rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   		; IRQ0 Handler                  
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;TIM1_OVF   ; Timer1 Overflow Handler       		
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   		; Timer0 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
;-------------------------------------------------------------------------------
; Interrupt-ERROR																
INTERRUPT_ERROR:
	LED_ROT_ON
	LED_GELB_ON
	LED_GRUEN_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GRUEN_OFF
	rcall WAIT_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)						; STACK initialisieren
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall Watchdog_aktivieren
	rcall SRAM_CLEAR
	rcall STARTWERTE
	rcall PORT_CLEAR
	rcall LED_INITIALISIERUNG
	rcall TWI_INI
	rcall ADC_INITIALISIERUNG
	rcall TIMER2_1ms_INITIALISIERUNG
	rcall TIMER_AKTIVIEREN
	rcall PROGRAMM_CHECK
	sei											; interrupts freigeben
;-------------------------------------------------------------------------------
	rcall TWI_OLED_INITIALISIERUNG
	rcall ANZEIGE_BEGRUESSUNG
	rcall WAIT_1s
	rcall OLED_CLEAR

	rcall OLED_TEST1
	rcall WAIT_1s
	rcall OLED_CLEAR

	rcall TWI_SCAN
	rcall WAIT_1s
	rcall OLED_CLEAR
	rcall BME680_INITIALISIERUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall BME680_DATA_READ
	rcall BME680_ANZEIGE_T
	
	rcall BME680_MESSUNG
	rcall WAIT_1s
	rcall PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "ADC.asm"
.include "ASCII.asm"
.include "ANZEIGE.asm"
.include "TIMER.asm"
.include "TWI.asm"
.include "TWI_OLED_SSD1306.asm"
.include "TWI_BME680.asm"
.include "SONSTIGES.asm"
.include "WAIT.asm"
.include "ZAHLEN.asm"

TEXT_BEGRUESSUNG_1:
.db "OLED ATmega8 ",0
TEXT_BEGRUESSUNG_2:
.db "02/2021 V6 ",0
TEXT_BEGRUESSUNG_3:
.db "128x64 Pixel ",0
TEXT_BEGRUESSUNG_4:
.db "8 MHz",0

TEXT_SCAN:
.db "SCAN...",0

TEXT_ERROR:
.db "Error",0
